package com.astrum.io;

import java.io.IOException;

public class IO485 extends IOUART {
	IOGpioOutput gpio;

	public IO485(Ports port, int baudrate, Parity parity, int dataBits, StopBits stopBit) {
		super(port, baudrate, parity, dataBits, stopBit);
		switch (port) {
		case UART1:
			this.gpio = new IOGpioOutput(IOGpioOutput.IOOutputNames.EXTERNAL_OUTPUT_1);
			break;
		case UART2:
			this.gpio = new IOGpioOutput(IOGpioOutput.IOOutputNames.EXTERNAL_OUTPUT_2);
			break;
		}
	}

	@Override
	protected boolean IOOpen() {
		boolean result = false;
		try {
			gpio.open();
			if ((result = super.IOOpen())) {
				NSetGPIO(this.nativeId, gpio.nativeId);
			}
		} catch (IOException e) {
			IOLog.logE(e);
		}
		return result;
	}

	@Override
	protected boolean IOClose() {
		try {
			gpio.close();
		} catch (IOException e) {
			IOLog.logE(e);
		}
		return super.IOClose();
	}
}
