package com.astrum.io;

import java.io.IOException;

public class IOGpioInput extends IOGPIO {
	public enum IOInputNames{
		INPUT_1("PH6"),
		INPUT_2("PH20"),
		INPUT_3("PH19"),
		INPUT_4("PH22"),
		INPUT_5("PH23");

		private final String text;
		IOInputNames(final String text) {
			this.text = text;
		}
		@Override
		public String toString() {
			return text;
		}
	}
	public IOGpioInput(IOInputNames input) {
		super(0, input.toString());
		setNonc(true);
	}

	public final boolean get() throws IOException {
		if (!isOpened()) {
			throw new IOException("Not Opened");
		}
		boolean result = nativeGet(nativeId);
		if (getNonc()) {
			return !result;
		}
		return result;
	}

}
