package com.astrum.io;

import java.io.IOException;

public class IOGpioOutput extends IOGPIO {
	public enum IOOutputNames{
		OUTPUT_1("PH26"),
		OUTPUT_2("PH27"),
		EXTERNAL_OUTPUT_1("PH18"),
		EXTERNAL_OUTPUT_2("PH17");
		private final String text;
		IOOutputNames(final String text) {
			this.text = text;
		}
		@Override
		public String toString() {
			return text;
		}
	}
	public IOGpioOutput(IOOutputNames output) {
		super(1, output.toString());
	}

	public final void put(boolean value) throws IOException {
		if (!isOpened()) {
			throw new IOException("Not Opened");
		}
		nativePut(nativeId, getNonc() ? !value : value);
	}

	public final boolean get() throws IOException {
		if (!isOpened()) {
			throw new IOException("Not Opened");
		}
		boolean result = nativeGet(nativeId);
		if (getNonc()) {
			return !result;
		}
		return result;
	}
}
