package com.astrum.io;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.List;

public class IOLog {
	public interface IOLogEventHandler {
		public void onLog(String log);

		public void onLogE(String log);

		public void onLogSystemError(String log, String Detail);

		public void onLogI(String log);

		public void onLogD(String log);

		public void onLogW(String log);
	}

	public static boolean enableStackTrace = false;
	static List<IOLogEventHandler> logListener = new ArrayList<>();

	public static void addLogListener(IOLogEventHandler handler) {
		if (!logListener.contains(handler)) {
			logListener.add(handler);
		}

	}

	public static void clearAllListener() {
		logListener.clear();
	}

	public static void removeLogListener(IOLogEventHandler handler) {
		logListener.remove(handler);
	}

	public static void log(String log) {
		String stacklog = log;
		if (enableStackTrace) {
			StackTraceElement[] stack = Thread.currentThread().getStackTrace();
			if (stack.length > 2) {
				stacklog = stack[2].toString() + "->" + log;
			}
		}
		for (IOLogEventHandler handler : logListener) {
			try {
				try {
					handler.onLog(stacklog);
				} catch (Exception e) {

				}
			} catch (Exception e) {

			}
		}
	}

	public static void logE(String log) {
		String stacklog = log;
		if (enableStackTrace) {
			StackTraceElement[] stack = Thread.currentThread().getStackTrace();
			if (stack.length > 2) {
				stacklog = stack[2].toString() + "->" + log;
			}
		}
		for (IOLogEventHandler handler : logListener) {
			try {
				try {
					handler.onLogE(stacklog);
				} catch (Exception e) {

				}
			} catch (Exception e) {

			}
		}
	}

	public static void logE(Exception ex) {
		StringWriter stringWriter = new StringWriter();
		ex.printStackTrace(new PrintWriter(stringWriter));
		for (IOLogEventHandler handler : logListener) {
			try {
				handler.onLogSystemError(ex.toString(), stringWriter.toString());
			} catch (Exception e) {

			}
		}
	}

	public static void logD(String log) {
		String stacklog = log;
		if (enableStackTrace) {
			StackTraceElement[] stack = Thread.currentThread().getStackTrace();
			if (stack.length > 2) {
				stacklog = stack[2].toString() + "->" + log;
			}
		}
		for (IOLogEventHandler handler : logListener) {
			try {
				try {
					handler.onLogD(stacklog);
				} catch (Exception e) {

				}
			} catch (Exception e) {

			}
		}
	}

	public static void logI(String log) {
		String stacklog = log;
		if (enableStackTrace) {
			StackTraceElement[] stack = Thread.currentThread().getStackTrace();
			if (stack.length > 2) {
				stacklog = stack[2].toString() + "->" + log;
			}
		}
		for (IOLogEventHandler handler : logListener) {
			try {
				try {
					handler.onLogI(stacklog);
				} catch (Exception e) {

				}
			} catch (Exception e) {

			}
		}
	}

	public static void LogW(String log) {
		String stacklog = log;
		if (enableStackTrace) {
			StackTraceElement[] stack = Thread.currentThread().getStackTrace();
			if (stack.length > 2) {
				stacklog = stack[2].toString() + "->" + log;
			}
		}
		for (IOLogEventHandler handler : logListener) {
			try {
				try {
					handler.onLogW(stacklog);
				} catch (Exception e) {

				}
			} catch (Exception e) {

			}
		}
	}
}
